'use strict';











var _chalk = require('chalk');var _chalk2 = _interopRequireDefault(_chalk);
var _jestValidate = require('jest-validate');function _interopRequireDefault(obj) {return obj && obj.__esModule ? obj : { default: obj };}

const BULLET = _chalk2.default.bold('\u25cf'); /**
                                                * Copyright (c) 2014, Facebook, Inc. All rights reserved.
                                                *
                                                * This source code is licensed under the BSD-style license found in the
                                                * LICENSE file in the root directory of this source tree. An additional grant
                                                * of patent rights can be found in the PATENTS file in the same directory.
                                                *
                                                * 
                                                */const createCLIValidationError = (unrecognizedOptions, allowedOptions) => {let title = `${BULLET} Unrecognized CLI Parameter`;let message;const comment =
  `  ${_chalk2.default.bold('CLI Options Documentation')}:\n` +
  `  http://facebook.github.io/jest/docs/cli.html\n`;

  if (unrecognizedOptions.length === 1) {
    const unrecognized = unrecognizedOptions[0];
    const didYouMeanMessage = (0, _jestValidate.createDidYouMeanMessage)(
    unrecognized,
    Array.from(allowedOptions));

    message =
    `  Unrecognized option ${_chalk2.default.bold((0, _jestValidate.format)(unrecognized))}.` + (
    didYouMeanMessage ? ` ${didYouMeanMessage}` : '');
  } else {
    title += 's';
    message =
    `  Following options were not recognized:\n` +
    `  ${_chalk2.default.bold((0, _jestValidate.format)(unrecognizedOptions))}`;
  }

  return new _jestValidate.ValidationError(title, message, comment);
};

const validateCLIOptions = (argv, options) => {
  const yargsSpecialOptions = ['$0', '_', 'help', 'h'];
  const allowedOptions = Object.keys(options).reduce(
  (acc, option) => acc.add(option).add(options[option].alias || option),
  new Set(yargsSpecialOptions));

  const unrecognizedOptions = Object.keys(argv).filter(
  arg => !allowedOptions.has(arg));


  if (unrecognizedOptions.length) {
    throw createCLIValidationError(unrecognizedOptions, allowedOptions);
  }

  return true;
};

module.exports = validateCLIOptions;